# -*- coding: utf-8 -*-

from rest_framework import exceptions, viewsets
from rest_framework.decorators import action

from thx.api.views import ThuxViewMixin
from thx.role.core.views import ThuxRoleViewSetMixin

from . import serializers
from ... import models


# JOB
class JobViewSet(ThuxRoleViewSetMixin, ThuxViewMixin, viewsets.ModelViewSet):
    queryset = models.Job.objects.all()
    serializer_class = serializers.JobSerializer

    @action(methods=['patch'], detail=True)
    def enable(self, request, **filters):
        return super().partial_update(request)

    @action(methods=['patch'], detail=True)
    def disable(self, request, **filters):
        return super().partial_update(request)


# JOB LOG
class JobLogViewSet(ThuxRoleViewSetMixin, ThuxViewMixin, viewsets.ModelViewSet):
    queryset = models.JobLog.objects.all()
    serializer_class = serializers.JobLogSerializer

    @action(methods=['patch'], detail=True)
    def enable(self, request, **filters):
        return super().partial_update(request)

    @action(methods=['patch'], detail=True)
    def disable(self, request, **filters):
        return super().partial_update(request)
